#include <stdio.h>
#include <string.h>

#include "resources.h"
#include "tasks.h"

#include "ff.h"
#include "bestf.h"
#include "edf.h"
#include "lstf.h"
#include "overhead.h"
#include "heuristic.h"

#include "result.h"
int main()
{
	struct tsk tasks_tmp[MAX_TASKS];
	
	struct dev devs_tmp[MAX_DEV];
	struct edge edges_tmp[MAX_EDGE];
	struct cloud clouds_tmp[MAX_CLOUD];

	init_resources();
	init_tasks();
	
	memcpy(tasks_tmp, tasks, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs_tmp, devs, MAX_DEV * sizeof(struct dev));
	memcpy(edges_tmp, edges, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds_tmp, clouds, MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));

	ff();
	print_title();
	print_result();

	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	ffd();
	print_result();

	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	edf();
	print_result();

	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	bestf();
	print_result();


	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	eftf();
	print_result();
	
	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	edf_eftf();
	print_result();

	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	lstf();
	print_result();

	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	small_ratio_size_slack_first();
	print_result();
	
	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	smallest_overhead_first();
	print_result();


	memcpy(tasks, tasks_tmp, MAX_TASKS * sizeof(struct tsk));
	memcpy(devs, devs_tmp, MAX_DEV * sizeof(struct dev));
	memcpy(edges, edges_tmp, MAX_EDGE * sizeof(struct edge));
	memcpy(clouds, clouds_tmp,MAX_CLOUD * sizeof(struct cloud));
	memset(&rst, 0, sizeof(struct result));
	heuristic();
	print_result();

	
	return 0;
}
