#ifndef _TASKS_H_
#define _TASKS_H_
#include "resources.h"

struct tsk{
	float length; //total length in e.g., GHz
	float sizeIn; //total data input size in e.g., MB
	float deadline; //deadline
	int para; //parallel degree
	struct dev *dev; //user device the task belonged
	struct tsk *next;
	struct tsk *pre;
};


#define MAX_TASKS 2048
extern int num_task;
extern float total_length;
extern float total_input;
extern struct tsk tasks[MAX_TASKS];

void init_tasks();

void sort_task_deadline_inc();
void sort_task_length_dec();
void sort_task_input_dec();
void sort_task_length_dec_part(struct tsk tasks[], int num_task);

#endif
